<?php

namespace Sendcloud\Shipping\Repositories;

use Sendcloud\Shipping\Models\Nominated_Day_Meta;

class Checkout_Payload_Meta_Repository {
	const CHECKOUT_PAYLOAD_META_FIELD_NAME = 'sendcloudshipping_checkout_payload_meta';

	/**
	 * Get service point based on order id
	 *
	 * @param $order_id
	 *
	 * @return Nominated_Day_Meta|null
	 */
	public function get_nominated_day( $order_id ) {
		$data = get_post_meta( $order_id, self::CHECKOUT_PAYLOAD_META_FIELD_NAME );
		if ( empty( $data[0]['nominated_day_delivery'] ) ) {
			return null;
		}

		return Nominated_Day_Meta::from_array( $data[0]['nominated_day_delivery'] );
	}

	/**
	 * Update service point
	 *
	 * @param $order_id
	 * @param array $raw_payload_data Raw checkout payload data array
	 *
	 */
	public function save_raw( $order_id, $raw_payload_data ) {
		update_post_meta( $order_id, self::CHECKOUT_PAYLOAD_META_FIELD_NAME, $raw_payload_data );
	}
}